SystemOrganization addCategory: #'GT-Tests-Inspector'!

GLMMorphicTest subclass: #GTUnprintableObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Inspector'!

!GTUnprintableObjectTest commentStamp: '<historical>' prior: 0!
GTUnprintableObjectTest is a test that checks that print string does not trigger an error in the inspector.!

!GTUnprintableObjectTest methodsFor: 'printing' stamp: 'TudorGirba 5/25/2012 17:13'!
printString
	"Simulate an error in printString"
	1/0! !

!GTUnprintableObjectTest methodsFor: 'tests' stamp: 'TudorGirba 5/25/2012 17:12'!
testInspectDoesNotCrash
	window := GTInspector openOn: self class new ! !

TestCase subclass: #GTInspectorDummyExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Inspector'!

!GTInspectorDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 9/12/2015 17:38'!
allExamplesDummiesProviders
	^ { 
		GTDummyExamples. 
		GTDummyExamplesPragmas. 
		GTDummyExamplesRecursive. 
		GTDummyExamplesWithDependencies. 
		GTDummyExamplesWithExternalDependencies.
		GTDummyExamplesWithExceptions 
	}! !

!GTInspectorDummyExamplesTest methodsFor: 'utils' stamp: 'StefanReichhart 9/12/2015 14:22'!
examplesInClasses: aSelector do: aBlock
	| classes examples |
	self shouldnt: [ classes  := (self perform: aSelector) ] raise: Error.
	classes do: [ :each |
		self shouldnt: [ examples := each gtExamples ] raise: Error.
		examples do: [ :example |
			self shouldnt: [ aBlock value: example ] raise: Error ] ]! !

!GTInspectorDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 9/12/2015 14:36'!
invalidExamplesDummiesProviders
	^ { 
		GTDummyExamplesInvalid.
	}! !

!GTInspectorDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 9/12/2015 14:41'!
recursiveExamplesDummiesProviders
	^ { 
		GTDummyExamplesRecursive.
	}! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testExists
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: example exists ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:36'!
testInvalidDefinitions
	self examplesInClasses: #invalidExamplesDummiesProviders do: [ :example | 
		self assert: example exists.
		self deny: example isValid ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testIsEquals
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: (example = example) ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testIsGTExample
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: example isGTExample ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testMatchesMethod
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: (example matchesMethod: example method) ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:40'!
testRecursiveDefinitions
	self examplesInClasses: #recursiveExamplesDummiesProviders do: [ :example | 
		self assert: example exists.
		self assert: example hasValidArguments.
		self assert: example hasValidDependencies.
		self assert: (example method selector = #h or: [ example isValid not ]) ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testResult
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self shouldnt: [ example result ] raise: Error.
		self shouldnt: [ example returnValue ] raise: Error.
		self shouldnt: [ example detachResultFromSystem ] raise: Error.
		self shouldnt: [ example result ] raise: Error.
		self shouldnt: [ example returnValue ] raise: Error. ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testRun
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self shouldnt: [ example run ] raise: Error ]! !

TestCase subclass: #GTInspectorExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Inspector'!

!GTInspectorExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 16:31'!
checkAllPresentationsOf: exampleToTest
	| browser window |
	(Pragma allNamed: #gtInspectorPresentationOrder: from: exampleToTest class to: Object) do: [ :eachPragma | 
		browser := GLMWrapper new.
		[	browser
				show: [ :composite | 
					(eachPragma selector findTokens: $:) size = 1
						ifTrue: [ exampleToTest perform: eachPragma selector with: composite ].
					(eachPragma selector findTokens: $:) size = 2
						ifTrue: [ exampleToTest perform: eachPragma selector with: composite with: browser ] ].
			window := browser openOn: exampleToTest ] 
				on: Error 
				do: [
					window ifNotNil: [ window delete ].
					self fail: (eachPragma method gtDisplayString, ' for ', exampleToTest gtDisplayString)  ].
		window ifNotNil: [ window delete ] ]! !

!GTInspectorExamplesTest methodsFor: 'running' stamp: 'StefanReichhart 9/12/2015 16:25'!
tearDown
	super tearDown.
	 
	(Smalltalk classNamed: #GTExampleOrganizer) 
		ifNotNil: [ :class | class instance resetResults ]! !

!GTInspectorExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 11:01'!
testAllExamples
	Object withAllSubclasses
		do: [ :eachClass | 
			eachClass gtExamples do: [ :exampleToTest | 
				self checkAllPresentationsOf: exampleToTest.
				exampleToTest detachResultFromSystem ] ]
		displayingProgress: 'Testing GTInspector examples (#testAllExamples)'! !

!GTInspectorExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 3/27/2015 19:46'!
testGlobals
	{ Smalltalk . RBMessageNode . Trait . TClass . TBehavior . GTInspector . Object . Class . CompiledMethod } 
		do: [ :each | self checkAllPresentationsOf: each ]
		displayingProgress: 'Testing GTInspector globals (#testGlobals)'! !

TestCase subclass: #GTInspectorVariableValuePairsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Inspector'!

!GTInspectorVariableValuePairsTest methodsFor: 'object' stamp: 'TommasoDalSasso 1/30/2015 17:33'!
testArrayPairs41
	| pairs |
	
	pairs := (1 to: 41) asArray gtInspectorVariableValuePairs.
	self assert: pairs size = 41.
	(pairs collect: #key) allSatisfy: [ :e | (pairs at: e) = e ].
	
	self assert: ((pairs collect: #key) = (1 to: 41) asOrderedCollection).! !

!GTInspectorVariableValuePairsTest methodsFor: 'object' stamp: 'TommasoDalSasso 1/30/2015 17:33'!
testArrayPairs42
	| pairs |
	
	pairs := (1 to: 42) asArray gtInspectorVariableValuePairs.
	self assert: pairs size = 42.
	(pairs collect: #key) allSatisfy: [ :e | (pairs at: e) = e ].
	
	self assert: ((pairs collect: #key) = (1 to: 42) asOrderedCollection).! !

!GTInspectorVariableValuePairsTest methodsFor: 'object' stamp: 'TommasoDalSasso 1/30/2015 17:34'!
testArrayPairs43
	| pairs |
	
	pairs := (1 to: 43) asArray gtInspectorVariableValuePairs.
	self assert: pairs size = 42.
	(pairs collect: #key) allSatisfy: [ :e | (pairs at: e) = e ].
	
	self assert: ((pairs collect: #key) = ((1 to: 21) asOrderedCollection addAll: (23 to: 43) asOrderedCollection; yourself)).! !

!GTInspectorVariableValuePairsTest methodsFor: 'object' stamp: 'TommasoDalSasso 1/30/2015 17:33'!
testArrayPairsLong
	| pairs |
	
	pairs := (1 to: 100) asArray gtInspectorVariableValuePairs.
	self assert: pairs size = 42.
	(pairs collect: #key) allSatisfy: [ :e | (pairs at: e) = e ].
	
	self assert: ((pairs collect: #key) = ((1 to: 21) asOrderedCollection addAll: (80 to: 100) asOrderedCollection; yourself)).! !

!GTInspectorVariableValuePairsTest methodsFor: 'object' stamp: 'TommasoDalSasso 1/30/2015 17:21'!
testArrayPairsSmall
	| pairs |
	
	pairs := (1 to: 10) asArray gtInspectorVariableValuePairs.
	self assert: pairs size = 10.
	(pairs collect: #key) allSatisfy: [ :e | (pairs at: e) = e ].! !

!GTInspectorVariableValuePairsTest methodsFor: 'context' stamp: 'TommasoDalSasso 1/30/2015 18:03'!
testContextPairs
	| pairs x tempVariables indexVariables instVariables |
	
	x:=42.
	pairs := [:y| y+1+x ] asContext gtInspectorVariableValuePairs withIndexCollect: [ :e :i | i -> e].	
	
	tempVariables := pairs select: [ :e | e value key asString beginsWith: '[' ].
	indexVariables := pairs select: [ :e | e value key isInteger ].
	instVariables := pairs select: [ :e | e value key isSymbol ].
	
	self assert: (tempVariables sort last key) < (indexVariables sort first key).
	self assert: (indexVariables sort last key) < (instVariables sort first key).! !

!GTInspectorVariableValuePairsTest methodsFor: 'float' stamp: 'TommasoDalSasso 1/30/2015 17:39'!
testFloatPairs
	| pairs |
	
	pairs := 4.2 gtInspectorVariableValuePairs.
	self assert: pairs size = 2.
	
	self assert: (pairs first = ('1' -> 1074842828)).
	self assert: (pairs second = ('2' -> 3435973837)).! !
